#pragma once
#include <memory>
#include "SDL2/SDL.h"
#include "Pin.h"



class Beam
{
public:
	Beam(SDL_Renderer* renderer, std::shared_ptr<Pin>& setPinConnection1, 
		std::shared_ptr<Pin>& setPinConnection2, bool setIsRoad = false);
	void draw(SDL_Renderer* renderer);
	bool getIsBroken();
	bool checkIfconnectedToPin(Pin& pin);
	void addForceAndMassDiv2AtPin(Pin& pin, Vector2D& forceSum, float& massSum);
	bool checkOverlapWithUnit(Vector2D posUnit, float radiusUnit);


private:
	Vector2D getForceAtPin(Pin& pin);


	const static float massPerLength, kStiffness, forceBeamMax;
	const static int thickness = 22;

	float length0 = 0.0f;
	float mass = 0.0f;

	bool isRoad;

	std::shared_ptr<Pin> pinConnection1 = nullptr, pinConnection2 = nullptr;

	float colorForceFactor = 0.0f;
	bool isBroken = false;

	SDL_Texture* texture = nullptr;
};