#pragma once
#include <vector>
#include <chrono>
#include <memory>
#include "SDL2/SDL.h"
#include "Pin.h"
#include "Beam.h"
#include "Unit.h"



class Game
{
private:
	enum class GameMode {
		playing,
		paused,
		victory,
		defeat
	} gameModeCurrent;


public:
	Game(SDL_Window* window, SDL_Renderer* renderer, int windowWidth, int windowHeight);
	~Game();


private:
	void processEvents(SDL_Renderer* renderer, bool& running);
	void update(float dT);
	void draw(SDL_Renderer* renderer);
	void setupBridge1(SDL_Renderer* renderer);
	void setupBridge2(SDL_Renderer* renderer);

	std::vector<std::shared_ptr<Beam>> listBeams;
	std::vector<std::shared_ptr<Pin>> listPins;
	Unit unitRedCreature;

	SDL_Texture* textureBackground = nullptr,
		* textureOverlayInstructions = nullptr,
		* textureOverlayVictory = nullptr,
		* textureOverlayDefeat = nullptr;

	bool overlayInstructionsVisible = true;
};