#include "MathAddon.h"


const float MathAddon::PI = 3.14159265359f, MathAddon::accGravity = (9.81f * 10.0f);




float MathAddon::angleRadToDeg(float angle) {
	return angle * 180.0f / PI;
}


float MathAddon::angleDegToRad(float angle) {
	return angle * PI / 180.0f;
}



bool MathAddon::checkOverlapLineCircle(Vector2D posLine1, Vector2D posLine2, Vector2D posCircle, float radiusCircle) {
	//Check to see if the line and cirlce overlap or not.
	Vector2D lengthCurrent = posLine1 - posLine2;
	Vector2D normalParallel = Vector2D(lengthCurrent).normalize();
	float distanceParallel = normalParallel.dot(posCircle - posLine2);

	float distanceCheck = 0.0f;
	if (distanceParallel < 0.0f)
		//The circle's center is past posLine2 so the check will see if it's within the circle.
		distanceCheck = (posLine2 - posCircle).magnitude();
	else if (distanceParallel > lengthCurrent.magnitude())
		//The circle's center is past posLine1 so the check will see if it's within the circle.
		distanceCheck = (posLine1 - posCircle).magnitude();
	else {
		//The perpendicular distance from the line to the center of the circle will be checked.
		Vector2D normalPerpendicular = normalParallel.getNegativeReciprocal();
		distanceCheck = abs(normalPerpendicular.dot(posLine2 - posCircle));
	}

	return (distanceCheck < radiusCircle);
}