#pragma once
#include <memory>
#include <vector>
#include "SDL2/SDL.h"
#include "Vector2D.h"
#include "TextureLoader.h"
#include "MathAddon.h"
class Beam;
class Unit;



class Pin
{
public:
	Pin(SDL_Renderer* renderer, Vector2D setPos, bool setPositionFixed = false);
	void update(float dT);
	void draw(SDL_Renderer* renderer);
	void calculateForces(std::vector<std::shared_ptr<Beam>>& listBeams, Unit& unitRedCreature);
	Vector2D getPos();


private:
	Vector2D pos, vel = Vector2D();
	bool positionFixed;

	Vector2D forceSumStored = Vector2D();
	float massSumStored = 0.0f;

	SDL_Texture* texture = nullptr;
};