#pragma once
#include "SDL2/SDL.h"
#include "Vector2D.h"
#include "TextureLoader.h"
#include "Beam.h"



class Unit
{
public:
	Unit(SDL_Renderer* renderer, Vector2D setPos);
	void update(float dT, std::vector<std::shared_ptr<Beam>>& listBeams);
	void draw(SDL_Renderer* renderer);
	void reset();
	bool checkIfTouchingBeam(std::shared_ptr<Beam> beam);
	void addForceAtPin(Vector2D& forceSum);
	bool getIsStuck();
	bool getReachedEndOfLevel();


private:
	bool checkOverlapWithBridgeAndLand(Vector2D posCheck, 
		std::vector<std::shared_ptr<Beam>>& listBeams, bool isFirstIteration);


	const Vector2D posStart;
	Vector2D pos;
	float speedY = 0.0f;
	static const float speedX, size, mass;

	bool isStuck = false, reachedEndOfLevel = false;

	SDL_Texture* texture = nullptr;

	std::vector<std::weak_ptr<Beam>> listBeamsTouching;
};